// tis the demo part

world
{
	mob = /mob;
	turf = /turf;
	view = "10x10";
	New()
	{
		gde_debug = 1; // lets turn the library's effect debugging on.
		..();
	}
}

// the two spell icons used in the demo were created and distributed by AbyssDragon


// if you want something to happen when a hud is clicked if you are displaying the hud, you can carry out the action
// with something like below

obj
{
	gde_hud // all the huds fall under this object type
	{
		Click() // clicky?
		{
			for(var/gdeffect/e in usr.gde_queue)
			{
				if("[e.gde_icon][e.gde_iconstate]" == "[src.icon][src.icon_state]")
				{
					usr << "\tName:      [e.gde_name]";
					usr << "\tDesc:      [e.gde_desc]";
					if(e.gde_duration != -1)
					{
						usr << "\tDuration:  [e.gde_duration] seconds";
						usr << "\tRemaining: [e.gde_rduration] seconds";
					}
					else
					{
						usr << "\tDuration:   Forever until cancelled.";
					}
					break;
				}
			}
		}
	}
}

// below i am adding two effects for the demo, slow and protect

gdeffect
{
	slow
	{
		gde_name = "Slow";
		gde_desc = "Limits movement speed for 15 seconds.";
		gde_overlay_icon = 'demo.dmi';
		gde_overlay_iconstate = "slow_overlay";
		gde_icon = 'demo.dmi';
		gde_iconstate = "slow";
		gde_duration = 15;         // a duration of -1 makes this effect remain until cancelled

		// this is called at the start of the effects duration, this is where you can do your own thing

		gde_enabled(mob/m)
		{
			m << "Slow has been casted on you!";
			m.slowed = 1;
		}

		// this is called when the effects duration is over, this is where you can do your own thing

		gde_disabled(mob/m)
		{
			if(src.gde_cancel)
			{
				m << "Protect has purified you of the slow spell!";
				m.slowed = 0;
			}
			else
			{
				m << "You no longer feel the effects of the slow spell!";
				m.slowed = 0;
			}
		}
	}
	protect
	{
		gde_name = "Protect";
		gde_desc = "Guards you temporarily from slow spells.";
		gde_overlay_icon = 'demo.dmi';
		gde_overlay_iconstate = "protect_overlay";
		gde_icon = 'demo.dmi';
		gde_iconstate = "protect";
		gde_duration = 15;

		// this is called at the start of the effects duration, this is where you can do your own thing

		gde_enabled(mob/m)
		{
			m << "Protect has been casted on you!";
			m.protected = 1;
		}

		// this is called when the effects duration is over, this is where you can do your own thing

		gde_disabled(mob/m)
		{
			m << "You no longer feel the effects of the protect spell!";
			m.protected = 0;
		}
	}
}

atom
{
	icon = 'demo.dmi';
}

turf
{
	icon_state = "wooden_floor";
}

mob
{
	icon_state = "mob";

	var
	{
		protected = 0;
		slowed = 0;
		moving = 0;
	}

	verb
	{
		HUD_Queue()
		{
			src << "<b>Queue Contains:</b>";
			for(var/obj/x in src.client.screen)
				world << "[x.name] ([x.screen_loc])";
		}
		View_Queue()
		{
			src << "<b>Queue Contains:</b>";
			var/count = 0;
			for(var/gdeffect/e in src.gde_queue)
			{
				count++;
				src << "\tName:      [e.gde_name]";
				src << "\tDesc:      [e.gde_desc]";
				if(e.gde_duration != -1)
				{
					src << "\tDuration:  [e.gde_duration] seconds";
					src << "\tRemaining: [e.gde_rduration] seconds";
				}
				else
				{
					src << "\tDuration:   Forever until cancelled.";
				}
			}

			if(!(count))
			{
				src << "\tQueue is empty.";
			}
		}
		Cast_Slow(mob/m in world)
		{
			if(m.protected)
			{
				src << "[m] is protected from your spell!";
			}
			else
			{
				src << "You have casted slow on [m]!";
				gde_add(m, "Slow");
			}
		}

		Cast_Protect(mob/m in world)
		{
			src << "You have casted protect on [m]!";
			if(m.slowed)
			{
				gde_cancel(m, "Slow");
			}
			gde_add(m, "Protect");
		}
	}

	Move()
	{
		if(src.slowed)
		{
			if(!(src.moving))
			{
				src.moving = 1;
				..();
				sleep(6)
				src.moving = 0;
			}
			else
			{
				return 0;
			}
		}
		else
		{
			return ..();
		}
	}

	Login()
	{
		src.gde_show_hud = 10; // we want the hud displayed for the effects on the 10th y of the client.screen
		                       // just don't set this to anything if you don't want the hud displayed
		world << "[src] has joined!";
		src.loc = locate(1, 1, 1);
	}

	Logout()
	{
		world << "[src] has left!";
		del(src)
	}
}