// tis the library part

mob
{
	var
	{
		list
		{
			gde_queue = new /list;
		}

		gde_show_hud = 0;
	}
}

var
{
	gde_debug = 0;
}

datum
{
	var
	{
		gde_name;
		gde_icon;
		gde_overlay_icon;
		gde_overlay_iconstate;
		gde_iconstate;
		gde_desc;
		gde_duration = 0;
		gde_rduration = 0;
		gde_cancel = 0;
	}

	proc
	{
		gde_enabled(mob/m)
		{
			if(gde_debug)
			{
				world << "gde_lib error with effect '[src.type]': gde_enabled(mob/m) undefined.";
			}
		}

		gde_disabled(mob/m)
		{
			if(gde_debug)
			{
				world << "gde_lib error with effect '[src.type]': gde_disabled(mob/m) undefined.";
			}
		}
	}
}

obj
{
	gde_hud
	{
		New(client/c, gdeffect/e, var/pos)
		{
			src.name = e.gde_name;
			src.icon = e.gde_icon;
			src.icon_state = e.gde_iconstate;
			src.layer = c.mob.layer + 1;
			src.screen_loc = pos;
			c.screen += src;
		}
	}
}

proc
{
	gde_cancel(mob/m, var/effect)
	{
		for(var/gdeffect/e in m.gde_queue)
		{
			if(e.gde_name == effect)
			{
				e.gde_cancel = 1;
			}
		}
	}
	gde_add(mob/m, var/effect)
	{
		for(var/e_type in typesof(/gdeffect/) - /gdeffect)
		{
			var/gdeffect/e = new e_type;

			if(gde_debug)
			{
				if(!(e.gde_name))
				{
					world << "gde_lib error with effect '[e.type]': gde_name undefined.";
				}
				else if(!(e.gde_icon))
				{
					world << "gde_lib error with effect '[e.type]': gde_icon undefined.";
				}
				else if(!(e.gde_desc))
				{
					world << "gde_lib error with effect '[e.type]': gde_desc undefined.";
				}
			}

			if(e.gde_name == effect)
			{
				e.gde_enabled(m);
				m.gde_queue += e;
				var/obj/o;
				if(e.gde_overlay_iconstate)
				{
					o = new;
					o.icon = e.gde_overlay_icon;
					o.icon_state = e.gde_overlay_iconstate;
					o.layer = m.layer + 30;
					m.overlays += o;
				}
				if(m.gde_show_hud)
				{
					gde_update_hud(m, m.gde_show_hud);
				}
				var/sleep_amount = e.gde_duration * 10;
				e.gde_rduration = e.gde_duration;
				if(e.gde_duration == -1)
				{
					while(e.gde_duration == -1)
					{
						if(e.gde_cancel)
						{
							break;
						}
					}
				}
				else
				{
					while(sleep_amount)
					{
						if(e.gde_cancel)
						{
							break;
						}
						else
						{
							sleep(10);
							sleep_amount -= 10;
							e.gde_rduration--;
						}
					}
				}
				m.gde_queue -= e;
				if(e.gde_overlay_iconstate)
				{
					m.overlays -= o;
					del(o);
				}
				if(m.gde_show_hud)
				{
					gde_update_hud(m, m.gde_show_hud);
				}
				e.gde_disabled(m)
				del(e);
				break;
			}
			else
			{
				del(e);
				continue;
			}
		}
	}

	gde_update_hud(mob/m, var/y_pos)
	{
		for(var/obj/gde_hud/e in m.client.screen)
		{
			del(e);
		}

		var/count = 0;
		for(var/gdeffect/e in m.gde_queue)
		{
			count++;
			var/pos = "[count],[y_pos]";
			new/obj/gde_hud(m.client, e, pos);
		}
	}
}